﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BaseProjectile : MonoBehaviour {
    public GameController gameController;
    public enum ProjectileType {PlayerStraight,PlayerStraightSine,EnemyStraight,EnemyStraightDirected}
    
    public float hitPoints;
    public float moveSpeed;
    public ProjectileType type;
    public string parent;
    // Use this for initialization
    void Start()
    {
        //Get GameControllerScript
        InitGameController();
    }

    //Manual Destroy
    public void Die()
    {
        Destroy(this);
    }

    public void InitGameController()
    {
        GameObject gameControllerObject = GameObject.FindWithTag("GameController");
        if (gameControllerObject != null)
        {
            gameController = gameControllerObject.GetComponent<GameController>();
        }
        if (gameController == null)
        {
            Debug.Log(name + " Cannot find 'GameController' script");
        }

    }

}
