﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BossCanonController : BaseEnemy
{
    public GameObject projectile;
    public GameObject player;
    public GameObject healthBar;
    //public GameController gameController;
    // Use this for initialization
    void Start()
    {
        InitGameController();

        player = gameController.GetPlayer();//GameObject.FindWithTag("Player");

    }

    void Update()
    {
        if (gameController.gameState == GameState.Playing)
        {
            if (player == null)
                player = gameController.GetPlayer();

            if (healthPoints <= 0.0f)
            {
                gameController.AddScore(rewardPoints);
                Instantiate(explosion, transform.position, transform.rotation);
                gameObject.SetActive(false);
                healthBar.SetActive(false);
            }


        }
    }
    void FixedUpdate()
    {
        if (gameController.gameState == GameState.Playing)
        {
            Rotate();
        }

        UpdateHud();

    }
    public void Activate()
    {
        //dont know why this executes when object is inactive so i chekc it here
        if (gameObject.activeSelf)
        {
            GameObject newProjectile = (GameObject)Instantiate(projectile, transform.position, transform.rotation);
            newProjectile.transform.GetComponent<EnemyProjectileController>().SetStraightDirected(player);
            newProjectile.transform.GetComponent<EnemyProjectileController>().SetEnemyAsParent();
        }

    }
    public void Rotate()
    {

        Vector2 dir = transform.position - player.transform.position;
        float angle = Mathf.Atan2(dir.y, dir.x) * Mathf.Rad2Deg;
        transform.rotation = Quaternion.AngleAxis(angle, Vector3.forward);
    }

    public void UpdateHud()
    {
        if (healthBar != null)
        {
            healthBar.GetComponent<UnityEngine.UI.Scrollbar>().size = healthPoints / totalHealthPoints;
        }
    }
}
