﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BossController : MonoBehaviour
{
    public GameObject leftLaser1;
    public GameObject leftLaser2;
    public GameObject leftCanon1;
    public GameObject rightLaser1;
    public GameObject rightLaser2;
    public GameObject rightCanon1;
    public GameController gameController;
    public GameEntityType type;
    public float healthPoints;
    public float canonElapsedTime;
    public float canonCooldown;

    public float canonTime;
    public float laserTime;

    public float InsideLaserElapsedTime;
    public float InsideLaserCooldown;

    public float OutsideLaserElapsedTime;
    public float OutsideLaserCooldown;

    public float InsideLaserCharge;
    public float OutsideLaserCharge;
    public AudioSource laserChargeSound;
    // Use this for initialization
    void Start()
    {
        InitGameController();


    }

    // Update is called once per frame
    void Update()
    {   /// Controll different timers for shooting
        if (gameController.gameState == GameState.Playing)
        {
            canonElapsedTime += Time.deltaTime;
            InsideLaserElapsedTime += Time.deltaTime;
            OutsideLaserElapsedTime += Time.deltaTime;

            if (canonElapsedTime >= canonCooldown)
            {
                canonElapsedTime = 0.0f;
                FireCanons();
            }
            if (InsideLaserElapsedTime >= InsideLaserCooldown)
            {
                InsideLaserElapsedTime = 0.0f;
                FireInsideLasers();
            }
            if (OutsideLaserElapsedTime >= OutsideLaserCooldown)
            {
                OutsideLaserElapsedTime = 0.0f;
                FireOutsideLasers();
            }

            if (InsideLaserElapsedTime >= 8.01f) // 8.01 used instead of 8.0 because of weird timings mismatch bug hwne using 8.00
            {   //TODO play laser charging sound here
                if (leftLaser1.GetComponent<BossLaserController>().laserCharge.isStopped)
                {
                    leftLaser1.GetComponent<BossLaserController>().laserCharge.Play();
                    if(leftLaser1.activeSelf && !laserChargeSound.isPlaying)
                        laserChargeSound.Play();
                }
                if (rightLaser1.GetComponent<BossLaserController>().laserCharge.isStopped)
                {
                    rightLaser1.GetComponent<BossLaserController>().laserCharge.Play();
                    if (rightLaser1.activeSelf && !laserChargeSound.isPlaying)
                        laserChargeSound.Play();
                }

            }
            if (OutsideLaserElapsedTime > 12.01)
            {
                if (leftLaser2.GetComponent<BossLaserController>().laserCharge.isStopped)
                {
                    leftLaser2.GetComponent<BossLaserController>().laserCharge.Play();
                    if (leftLaser2.activeSelf && !laserChargeSound.isPlaying)
                        laserChargeSound.Play();
                }
                if (rightLaser2.GetComponent<BossLaserController>().laserCharge.isStopped)
                {
                    rightLaser2.GetComponent<BossLaserController>().laserCharge.Play();
                    if (rightLaser2.activeSelf && !laserChargeSound.isPlaying)
                        laserChargeSound.Play();
                }

            }

            if (leftLaser1.activeSelf == false && leftLaser2.activeSelf == false
                && rightLaser1.activeSelf == false && rightLaser2.activeSelf == false
                && rightCanon1.activeSelf == false && leftCanon1.activeSelf == false)
                Destroy(gameObject);
        }

    }
    public void FireInsideLasers()
    {
        leftLaser1.GetComponent<BossLaserController>().Activate();
        rightLaser1.GetComponent<BossLaserController>().Activate();
    }
    public void FireOutsideLasers()
    {
        leftLaser2.GetComponent<BossLaserController>().Activate();
        rightLaser2.GetComponent<BossLaserController>().Activate();
    }
    public void FireLasers()
    {
        leftLaser1.GetComponent<BossLaserController>().Activate();
        leftLaser2.GetComponent<BossLaserController>().Activate();
        rightLaser1.GetComponent<BossLaserController>().Activate();
        rightLaser2.GetComponent<BossLaserController>().Activate();

    }
    public void FireCanons()
    {
        leftCanon1.GetComponent<BossCanonController>().Activate();
        rightCanon1.GetComponent<BossCanonController>().Activate();

    }
    public void InitGameController()
    {
        GameObject gameControllerObject = GameObject.FindWithTag("GameController");
        if (gameControllerObject != null)
        {
            gameController = gameControllerObject.GetComponent<GameController>();
        }
        if (gameController == null)
        {
            Debug.Log(name + " Cannot find 'GameController' script");
        }

    }
}
