﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BossLaserController : BaseEnemy
{
    private LineRenderer lineRenderer;
    public Transform lineHit;

    public float duration;
    public float elapsedTime;
    public bool active;
    public float offset;
    public ParticleSystem laserCharge;
    public GameObject healthBar;
    // Use this for initialization
    void Start()
    {
        InitGameController();

        lineRenderer = GetComponent<LineRenderer>();
        lineRenderer.enabled = false;
        lineRenderer.useWorldSpace = true;
        elapsedTime = 0.0f;

        laserCharge = GetComponentInChildren<ParticleSystem>();
        laserCharge.Stop();

    }

    // Update is called once per frame
    void Update()
    {
        //14.3 is right camera border position
        if (gameController.gameState == GameState.Playing)
        {
            if (healthPoints <= 0.0f)
            {
                gameController.AddScore(rewardPoints);
                Instantiate(explosion, transform.position, transform.rotation);
                //Destroy(gameObject);
                gameObject.SetActive(false); //Destroy(gameObject); used setactive to avoid null pointers in boss object
                healthBar.SetActive(false);
            }

            if (active)
            {
                //TODO play laser sound here
                lineRenderer.enabled = true;
                elapsedTime += Time.deltaTime;
                RayCastLogic();

            }
            else
            {
                elapsedTime = 0.0f;
                lineRenderer.enabled = false;
            }
            if (elapsedTime >= duration)
            {
                active = false;
            }
        }

    }
    void FixedUpdate()
    {
        UpdateHud();

    }
    public void RayCastLogic()
    {
        float dist = 14.3f + transform.position.x;
        Vector2 position = transform.position;
        position.x += offset;
        RaycastHit2D[] hits = Physics2D.RaycastAll(position, -transform.right, dist);
        foreach (RaycastHit2D hit in hits)
        {
            GameObject collidedWith = hit.collider.gameObject;

            if (collidedWith.GetComponent<BaseShip>() != null)
            {
                GameEntityType t = collidedWith.GetComponent<BaseShip>().type;

                if (t == GameEntityType.PlayerShip)
                {
                    //collidedWith.GetComponent<BaseShip>().RecieveDamage(collidedWith.GetComponent<BaseShip>().healthPoints);
                    collidedWith.GetComponent<BaseShip>().RecieveDamage(gameController.fixedEnemyDamage);
                    //collidedWith.GetComponent<PlayerController>().recieveDamageSound.Play();
                }

            }
        }

        lineRenderer.SetPosition(0, position);
        lineRenderer.SetPosition(1, new Vector2(-14.3f, transform.position.y));
    }
    public void Activate()
    {
        active = true;
    }

    public void UpdateHud()
    {
        if (healthBar != null)
        {
            healthBar.GetComponent<UnityEngine.UI.Scrollbar>().size = healthPoints / totalHealthPoints;
        }
    }
}
