﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BossTrigger : MonoBehaviour {
    public GameObject boss;
    public GameController gameController;
    public float elapsedTime;
    ParticleSystem spawnParticle;
    // Use this for initialization
    void Start () {
        InitGameController();
	}
	
    private void OnTriggerEnter2D(Collider2D collision)
    {
        GameObject collidedWith = collision.gameObject;

        if (collidedWith.name == "Main Camera")
        {
            //TODO play boss spawn sound here
            spawnParticle = Instantiate(gameController.bossSpawnParticle);
            Invoke("ActivateBoss", 1.0f);
        }
     
    }

    private void InitGameController()
    {
        GameObject gameControllerObject = GameObject.FindWithTag("GameController");
        if (gameControllerObject != null)
        {
            gameController = gameControllerObject.GetComponent<GameController>();
        }
        if (gameController == null)
        {
            Debug.Log("Cannot find 'GameController' script");
        }

    }
    /// <summary>
    /// Enables boss character its UI elements, music theme
    /// </summary>
    private void ActivateBoss()
    {
        //boss.SetActive(true);
        gameController.boss.SetActive(true);
        gameController.bossUI.SetActive(true);
        Destroy(spawnParticle.gameObject);
        gameController.PlayBossTheme();
    }
}
