﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy1 : BaseEnemy
{
    public GameObject projectile;
    public GameObject player;
    public float nextFire;

    void Start()
    {
        InitGameController();
        player = gameController.GetPlayer();
        onMap = false;
    }

    void FixedUpdate()
    {
        if (gameController.gameState == GameState.Playing)
        {
            Move();
        }
    }

    void Update()
    {
        if (gameController.gameState == GameState.Playing)
        {
            if (healthPoints <= 0.0f)
            {
                gameController.AddScore(rewardPoints);
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);
            }
        }
    }
    private void OnTriggerEnter2D(Collider2D collision)
    {
        GameObject collidedWith = collision.gameObject;

        if (collidedWith.name == "Main Camera")
        {
            transform.parent = null;
            onMap = true;
            InvokeRepeating("PrimaryShoot", 2.0f, 1.0f);
        }
        else if (collidedWith.GetComponent<BaseShip>() != null)
        {
            if (collidedWith.GetComponent<BaseShip>().type == GameEntityType.PlayerShip)
            {
                //If enemy collides with player destroy enemy
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);
            }
        }
    }
    public void Move()
    {

        if (onMap)
        {
            Vector2 position = transform.position;
            position = new Vector2(position.x - moveSpeed * Time.deltaTime, position.y);
            transform.position = position;
        }

    }
    /// <summary>
    /// Shoot at player
    /// </summary>
    public void PrimaryShoot()
    {
        if (player == null)
            player = gameController.GetPlayer();
        //get player direction an shoot at it
        GameObject newProjectile = (GameObject)Instantiate(projectile, transform.position, transform.rotation);
        newProjectile.transform.GetComponent<EnemyProjectileController>().SetStraightDirected(player);
        newProjectile.transform.GetComponent<EnemyProjectileController>().SetEnemyAsParent();
    }


}
