﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy3 : BaseEnemy
{

    public GameObject projectile;
    public GameObject player;
    public float nextFire;

    // Use this for initialization
    void Start()
    {

        InitGameController();
        onMap = false;
    }

    void FixedUpdate()
    {
        if (gameController.gameState == GameState.Playing)
        {
            Move();
        }
    }

    void Update()
    {
        if (gameController.gameState == GameState.Playing)
        {
            if (healthPoints <= 0.0f)
            {
                gameController.AddScore(rewardPoints);
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);
            }

        }
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        GameObject collidedWith = collision.gameObject;

        if (collidedWith.name == "Main Camera")
        {
            transform.parent = null;
            onMap = true;
            InvokeRepeating("PrimaryShoot", 2.0f, 1.0f);
        }
        else if (collidedWith.GetComponent<BaseShip>() != null)
        {
            if (collidedWith.GetComponent<BaseShip>().type == GameEntityType.PlayerShip)
            {
                //ff enemy collides with player destroy enemy
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);
            }
        }


    }
    public void Move()
    {

        if (onMap)
        {
            transform.Rotate(Vector3.forward);
            Vector2 position = transform.position;
            position = new Vector2(position.x - moveSpeed * Time.deltaTime, position.y);
            transform.position = position;
        }

    }
    public void PrimaryShoot()
    {
        foreach (GameObject canon in canonList)
        {
            GameObject newProjectile = (GameObject)Instantiate(projectile, canon.transform.position, transform.rotation);
            newProjectile.transform.GetComponent<EnemyProjectileController>().SetStraightDirected((canon.transform.position + (canon.transform.position - transform.position)));
            newProjectile.transform.GetComponent<EnemyProjectileController>().SetEnemyAsParent();

        }

    }



}
