﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy4 : BaseEnemy
{
    // Use this for initialization
    void Start()
    {

        InitGameController();
        onMap = false;
    }

    void FixedUpdate()
    {
        if (gameController.gameState == GameState.Playing)
        {
            Move();
        }
    }

    void Update()
    {
        if (gameController.gameState == GameState.Playing)
        {
            if (healthPoints <= 0.0f)
            {
                gameController.AddScore(rewardPoints);
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);
            }
        }
    }
    public void Move()
    {

        if (onMap)
        {
            Vector2 position = transform.position;
            position = new Vector2(position.x - moveSpeed * Time.deltaTime, position.y);
            transform.position = position;
        }

    }


    private void OnTriggerEnter2D(Collider2D collision)
    {
        GameObject collidedWith = collision.gameObject;

        if (collidedWith.name == "Main Camera") //do this by tag
        {
            transform.parent = null;
            onMap = true;
        }
        else if (collidedWith.GetComponent<BaseShip>() != null)
        {
            if (collidedWith.GetComponent<BaseShip>().type == GameEntityType.PlayerShip)
            {
                //If enemy collides with player destroy enemy
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);
            }
        }


    }

}
