﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy5 : BaseEnemy
{

    // Use this for initialization
    void Start()
    {
        InitGameController();
        onMap = false;
    }


    void FixedUpdate()
    {
        if (gameController.gameState == GameState.Playing)
        {
            Move();
        }
    }

    void Update()
    {
        if (gameController.gameState == GameState.Playing)
        {
            if (healthPoints <= 0.0f)
            {
                gameController.AddScore(rewardPoints);
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);
            }
        }
    }
    public void Move()
    {

        if (onMap)
        {
            if (gameController.player != null)
                transform.position = Vector2.MoveTowards(transform.position, gameController.player.transform.position, moveSpeed * Time.deltaTime);
            else
                transform.position = Vector2.MoveTowards(transform.position, new Vector2(-30.0f, 0.0f), moveSpeed * Time.deltaTime);
        }

    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        GameObject collidedWith = collision.gameObject;

        if (collidedWith.name == "Main Camera") //do this by tag
        {
            transform.parent = null;
            onMap = true;
        }
        else if (collidedWith.GetComponent<BaseShip>() != null)
        {
            if (collidedWith.GetComponent<BaseShip>().type == GameEntityType.PlayerShip)
            {
                //If enemy collides with player destroy enemy
                Instantiate(explosion, transform.position, transform.rotation);
                Destroy(gameObject);

            }
        }


    }

}
