﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Preferences : MonoBehaviour {

    string music = "MusicVolume";
    string sfx = "SoundEffectsVolume";
    string highscore = "HighScore";
    public  float musicVal;
    public  float sfxVal;
    public  float highscoreVal;
    public GameObject musicSlider;
    public GameObject sfxSlider;
    // Use this for initialization
    void Start()
    {
        if (PlayerPrefs.HasKey(music))
        {
            musicVal = PlayerPrefs.GetFloat(music);
            musicSlider.GetComponent<UnityEngine.UI.Slider>().value = musicVal;
        }else
        {
            musicVal = 0.5f;
            PlayerPrefs.SetFloat(music, musicVal);
            musicSlider.GetComponent<UnityEngine.UI.Slider>().value = musicVal;
        }
        if (PlayerPrefs.HasKey(sfx))
        {
            sfxVal = PlayerPrefs.GetFloat(sfx);
            sfxSlider.GetComponent<UnityEngine.UI.Slider>().value = sfxVal;
        }else
        {
            sfxVal = 0.5f;
            PlayerPrefs.SetFloat(sfx, sfxVal);
            sfxSlider.GetComponent<UnityEngine.UI.Slider>().value = sfxVal;
        }
        if (PlayerPrefs.HasKey(highscore))
        {
            highscoreVal = PlayerPrefs.GetFloat(highscore);
        }else
        {
            PlayerPrefs.SetFloat(highscore, 0.0f);
        }
    }
    // Update is called once per frame
    void Update()
    {

    }

    public void SetMusicVolume()
    {
        musicVal = musicSlider.GetComponent<UnityEngine.UI.Slider>().value;
        PlayerPrefs.SetFloat(music, musicVal);
    }

    public void SetSfxVolume()
    {
        sfxVal = sfxSlider.GetComponent<UnityEngine.UI.Slider>().value;
        PlayerPrefs.SetFloat(sfx, sfxVal);
    }

    public void SetHighScore(float newHighScore)
    {
        if(highscoreVal < newHighScore)
        {
            highscoreVal = newHighScore;
            PlayerPrefs.SetFloat(highscore, highscoreVal);
        }
        PlayerPrefs.Save();
    }
    public void SavePreferences()
    {
        PlayerPrefs.Save();
    }

}
