﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerLaserController : MonoBehaviour {
    private LineRenderer lineRenderer;
    public Transform lineHit;
    public GameController gameController;
    public float duration;
    public float elapsedTime;
    public bool active;
	// Use this for initialization
	void Start () {
        InitGameController();

        lineRenderer = GetComponent<LineRenderer>();
        lineRenderer.enabled = false;
        lineRenderer.useWorldSpace = true;
        elapsedTime = 0.0f;
	}
	
	// Update is called once per frame
	void Update () {
        //14.3 is rigght camera border position
        if (gameController.gameState == GameState.Playing)
        {
            if (Input.GetButton("Fire2"))
            {
                active = true;
                lineRenderer.enabled = true;
            }

            if (active)
            {
                elapsedTime += Time.deltaTime;
                RayCastLogic();
            }
            else
            {
                elapsedTime = 0.0f;
                lineRenderer.enabled = false;
            }
            if (elapsedTime >= duration)
            {
                active = false;
            }

        }

            //lineRenderer.SetPosition(1, hit.point);

    }
    public void RayCastLogic()
    {
        float dist = 14.3f - transform.position.x;
        RaycastHit2D[] hits = Physics2D.RaycastAll(transform.position, transform.right, dist);
        foreach (RaycastHit2D hit in hits)
        {
            GameObject collidedWith = hit.collider.gameObject;

            if (collidedWith.GetComponent<BaseShip>() != null)
            {
                GameEntityType t = collidedWith.GetComponent<BaseShip>().type;

                if (t == GameEntityType.EnemyShip || t == GameEntityType.EnemyBoss)
                {
                    collidedWith.GetComponent<BaseShip>().RecieveDamage(collidedWith.GetComponent<BaseShip>().healthPoints);
                }

            }
        }

        lineRenderer.SetPosition(0, transform.position);
        lineRenderer.SetPosition(1, new Vector2(14.3f, transform.position.y));
    }
    public void InitGameController()
    {
        GameObject gameControllerObject = GameObject.FindWithTag("GameController");
        if (gameControllerObject != null)
        {
            gameController = gameControllerObject.GetComponent<GameController>();
        }
        if (gameController == null)
        {
            Debug.Log(name + " Cannot find 'GameController' script");
        }

    }
}
