﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyProjectileController : BaseProjectile
{
    private Rigidbody2D _rigidbody;
    private Vector2 direction;
    private bool directionReady;

    // Use this for initialization
    void Start()
    {
        InitGameController();
        //directionReady = false;
        moveSpeed = 5.0f;
        hitPoints = 10;
    }

    // Update is called once per frame

    void Update()
    {
        if (type == ProjectileType.EnemyStraightDirected)
        {
            MoveStraightDirected();
        }
        else if (type == ProjectileType.EnemyStraight)
        {
            MoveStraight();
        }
    }

    public void SetStraightDirected(GameObject target)
    {
        type = ProjectileType.EnemyStraightDirected;
        Vector2 dir;
        if (target != null)
        {
            dir = target.transform.position - this.transform.position;
        }
        else
        {
            dir = new Vector2(0f, 0f);
        }


        direction = dir.normalized;
        directionReady = true;
    }

    public void SetStraightDirected(Vector3 target)
    {
        type = ProjectileType.EnemyStraightDirected;
        Vector2 dir = target - this.transform.position;

        direction = dir.normalized;
        directionReady = true;
    }
    public void MoveStraightDirected()
    {
        if (directionReady)
        {
            Vector2 positionTemp = transform.position;
            positionTemp += direction * moveSpeed * Time.deltaTime;
            transform.position = positionTemp;
        }
    }
    public void SetStraight()
    {
        type = ProjectileType.EnemyStraight;
    }
    public void MoveStraight()
    {

        Vector2 positionTemp = transform.position;
        positionTemp += (Vector2)transform.right * (moveSpeed * Time.deltaTime);
        transform.position = positionTemp;

    }
    public void SetEnemyAsParent()
    {
        this.parent = "Enemy";

    }
    private void OnTriggerEnter2D(Collider2D collision)
    {

        GameObject collidedWith = collision.gameObject;//collision.gameObject.name;

        if (collidedWith.GetComponent<BaseShip>() != null)
        {
            GameEntityType t = collidedWith.GetComponent<BaseShip>().type;
            if (t == GameEntityType.PlayerShip)
            {

                collidedWith.GetComponent<BaseShip>().RecieveDamage(gameController.fixedEnemyDamage);
                collidedWith.GetComponent<PlayerController>().recieveDamageSound.Play();
                if (collidedWith.GetComponent<BaseShip>().alive)
                {
                    collidedWith.GetComponent<BaseShip>().StartCoroutine(collidedWith.GetComponent<BaseShip>().Blink(0.04f));
                }
                Destroy(gameObject);
            }

        }

        if (collidedWith.tag == "Barier")
        {
            // Debug.Log(collidedWith.tag);

            Destroy(gameObject);
        }
        //enalbe use full kinematic contacts for it to work
    }
}
