﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerProjectileController : BaseProjectile
{
    public float sineFrequency;
    public float sineMagnitude;
    public Vector2 sineAxis;
    public Vector2 direction;
    public Vector2 position;
    public Vector2 right;
    public Rigidbody2D _rigidbody;
    // Use this for initialization
    void Start()
    {
        InitGameController();

        direction = new Vector2(0.2f, 0.0f);
        //moveSpeed = 20.0f;
        //sineFrequency = 50.0f;
        //sineMagnitude = 0.5f;
        position = transform.position;
        sineAxis = transform.up;
        right = transform.right;
        //hitPoints = 10;
    }

    // Update is called once per frame
    void Update()
    {
        if (type == ProjectileType.PlayerStraightSine)
        {
            MoveStraightSine();
        }
        else if (type == ProjectileType.PlayerStraight)
        {
            MoveStraight();
        }
    }
    public void MoveStraightSine()
    {
        position += right * Time.deltaTime * moveSpeed + direction;
        transform.position = position + sineAxis * Mathf.Sin(Time.time * sineFrequency) * sineMagnitude;
    }
    public void SetPlayerAsParent()
    {
        parent = "Player";

    }
    public void MoveStraight()
    {
        Vector2 positionTemp = transform.position;
        positionTemp += right * moveSpeed * Time.deltaTime;
        transform.position = positionTemp;
    }
    public void SetPlayerStraightSine()
    {
        type = ProjectileType.PlayerStraightSine;
    }

    public void SetPlayerStraight()
    {
        type = ProjectileType.PlayerStraight;
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {

        GameObject collidedWith = collision.gameObject;//collision.gameObject.name;

        if (collidedWith.GetComponent<BaseShip>() != null)
        {
            GameEntityType t = collidedWith.GetComponent<BaseShip>().type;

            if (t == GameEntityType.EnemyShip || t == GameEntityType.EnemyBoss || t == GameEntityType.EnemyBossPart)
            {
                collidedWith.GetComponent<BaseShip>().RecieveDamage(hitPoints);
                collidedWith.GetComponent<BaseShip>().StartCoroutine(collidedWith.GetComponent<BaseShip>().Blink(0.04f));
                Destroy(gameObject);
            }

        }
        if (collidedWith.tag == "Barier")
        {

            Destroy(gameObject);
        }
    }
}
